#pragma once

#include "CoreMinimal.h"
#include "OnGameEventActionInterface.h"
#include "CompetenceAction.h"
#include "K41UpdateFastTravelChargeConsumptionOnHookedSurvivorAction.generated.h"

class UFloatValueStrategy;

UCLASS(Blueprintable, EditInlineNew)
class UK41UpdateFastTravelChargeConsumptionOnHookedSurvivorAction : public UCompetenceAction, public IOnGameEventActionInterface
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_IsSlowDischargeRateActive, meta=(AllowPrivateAccess=true))
	bool _isSlowDischargeRateActive;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UFloatValueStrategy* _fastTravelDischargeRateMultiplier;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UFloatValueStrategy* _timerDuration;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_IsSlowDischargeRateActive();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UK41UpdateFastTravelChargeConsumptionOnHookedSurvivorAction();
};

FORCEINLINE uint32 GetTypeHash(const UK41UpdateFastTravelChargeConsumptionOnHookedSurvivorAction) { return 0; }
